import { join } from 'path';
import fs from 'fs-extra';
import { METADATA_FILE } from '../constants.js';

export const generateMetadata = async ({
  constants: { PUBLISH_DIR: dest },
  packageJson,
  utils: { build },
}) => {
  const { version } = packageJson;
  const url = process.env.DEPLOY_URL;

  if (!version || !url) return null;

  const metadata = { versions: { [`v${version}`]: url } };
  const file = `${METADATA_FILE}.json`;

  try {
    // eslint-disable-next-line import/no-named-as-default-member
    await fs.writeJSON(join(dest, file), metadata);

    console.log(`Generated ${file}:`);
    console.log(metadata);
  } catch (error) {
    build.failPlugin(`Failed to generate ${file}`, { error });
  }
};
